Bug 162293 - step into a tag handler in JSP page doesn't work
step into a tag handler in JSP page doesn't work
Status: STARTED
Product: javaee
Classification: Unclassified
Component: Debugger
6.x
Sun All
: P3 (vote)
: 6.x
Assigned To: Martin Entlicher
issues@javaee
fix-in-fcs
: REGRESSION
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2009-04-09 12:22 UTC by Jindrich Sedek
Modified: 2009-05-19 15:58 UTC (History)
3 users (show)

See Also:
Issue Type: DEFECT
:


Attachments
Application that reproduces this bug (21.43 KB, application/x-compressed)
2009-04-16 09:50 UTC, Petr Jiricka
Details
Stack trace (1.54 KB, text/plain)
2009-04-16 14:58 UTC, Petr Jiricka
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Jindrich Sedek 2009-04-09 12:22:17 UTC
Create new WebApplication
Create new tag library
Create new tag handler and add the taglibrary
import taglibrary into JSP page and use the library tag
set breakpoint at the line of usage of the library tag
invoke debug JSP, project is deployed, debugger attached, IDE stops on breakpoint
invoke "Step Into" once -> nothing happens
invoke Step Into few times -> Logger.java file is open and you can debug it while trying to get out of this class Using 
Set Out, System.java and HashMap.java got openned, but my tag handler got open as probably fifth file, but I was not 
navigated in the "doTag" method but in the class declaration and I had to press some more Step Out, Step Next, Step 
Into to navigate to my code in tag handler
Comment 1 Jindrich Sedek 2009-04-09 12:25:20 UTC
this is regression - it worked better in 6.5.1 - I need to press Step Into for few times to navigate to my code, but at 
least no other files from JDK got opened
Comment 2 Petr Jiricka 2009-04-10 10:26:46 UTC
Martin, any idea what could be wrong? Thanks.
Comment 3 Petr Jiricka 2009-04-16 09:50:27 UTC
Created attachment 80221 [details]
Application that reproduces this bug
Comment 4 Petr Jiricka 2009-04-16 10:00:42 UTC
I am able to reproduce (with GlassFish v2.1 as the target server). I attached the application that reproduces the issue.
Comment 5 Petr Jiricka 2009-04-16 14:56:10 UTC
When I try Shift-F7, there is an exception, see attached.
Comment 6 Petr Jiricka 2009-04-16 14:58:08 UTC
Created attachment 80263 [details]
Stack trace
Comment 7 Martin Entlicher 2009-04-16 15:12:20 UTC
The attached exception is already submitted as issue #162740.
I'll try to reproduce and hopefully find out what's wrong...
Comment 8 Martin Entlicher 2009-04-17 09:23:29 UTC
I've reproduced the behavior. This is mostly caused by enabled stepping into JDK classes, which is now on by default.
Stepping filters should help here, ClassLoader is correctly skipped, but it looks like the "Step through" option is not
correctly interpretted and execution ends up in Logger.

Also, the first Step Into goes into the same location, but in the next frame. It looks like nothing has happened, but
execution actually stepped into in the Java code that is underneath. Is it possible to see the generated Java code
somewhere?
Comment 9 Jindrich Sedek 2009-04-17 09:32:08 UTC
If you mean generated code of JSP page, use ViewServlet action on JSP file
Comment 10 Martin Entlicher 2009-04-17 09:40:52 UTC
Yes, thanks. View Servlet was what I need. Having that on a context menu in Editor would be handy.
Comment 11 Martin Entlicher 2009-04-17 15:23:31 UTC
I believe that the major problem was fixed in changeset:   127653:d638dc946f45
http://hg.netbeans.org/main/rev/d638dc946f45

You should not end up in JDK code now.

However, the behavior is still not perfect, first Step Into ends up on the same line, second goes to the non-existent
constructor and finally third goes into the doTag() method.
This is a subject of further investigation...
Comment 12 Quality Engineering 2009-04-18 07:23:37 UTC
Integrated into 'main-golden', will be available in build *200904180201* on http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)
Changeset: http://hg.netbeans.org/main-golden/rev/d638dc946f45
User: mentlicher@netbeans.org
Log: #162293 - Stepping options are better interpretted, handling of step requests improved.
Comment 13 Quality Engineering 2009-04-20 20:22:54 UTC
Integrated into 'main-golden', will be available in build *200904201507* on http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)
Changeset: http://hg.netbeans.org/main-golden/rev/d638dc946f45
User: mentlicher@netbeans.org
Log: #162293 - Stepping options are better interpretted, handling of step requests improved.
Comment 14 Marek Fukala 2009-05-19 13:49:40 UTC
Is this still P2 after the fix? I tend to downgrade it to P3 now. Jindro, can you please verify it? Thanks.
Comment 15 Jindrich Sedek 2009-05-19 14:42:12 UTC
I can verify that the behavior is better than before. Once I was redirected into Class.java file for unknown reason, 
but it could be threated as P3 for 6.7
Comment 16 Marek Fukala 2009-05-19 15:58:54 UTC
After agreement with QE and mentlicher downgrading to P3.


By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2012, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo